/* test.c was originally generated by the autoSql program, which also 
 * generated test.h and test.sql.  This module links the database and the RAM 
 * representation of objects. */
#include "common.h"
#include "jksql.h"
#include "test.h"

static char const rcsid[] = "$Id: hardTest.c,v 1.2 2003/05/06 07:22:14 kate Exp $";

void pointStaticLoad(char **row, struct point *ret)
/* Load a row from point table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne;
char *s;

ret->x = sqlSigned(row[0]);
ret->y = sqlSigned(row[1]);
ret->z = sqlSigned(row[2]);
}

struct point *pointLoad(char **row)
/* Load a point from row fetched with select * from point
 * from database.  Dispose of this with pointFree(). */
{
struct point *ret;
int sizeOne;
char *s;

AllocVar(ret);
ret->x = sqlSigned(row[0]);
ret->y = sqlSigned(row[1]);
ret->z = sqlSigned(row[2]);
return ret;
}

struct point *pointCommaIn(char *s)
/* Create a point out of a comma separated string. */
{
struct point *ret;
char *s = *pS;
int i;

AllocVar(ret);
ret->x = sqlSignedComma(&s);
ret->y = sqlSignedComma(&s);
ret->z = sqlSignedComma(&s);
*pS = s;
return ret;
}

void pointFree(struct point **pEl)
/* Free a single dynamically allocated point such as created
 * with pointLoad(). */
{
struct point *el;

if ((el = *pEl) == NULL) return;
freez(pEl);
}

void pointFreeList(struct point **pList)
/* Free a list of dynamically allocated point's */
{
struct point *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    pointFree(&el);
    }
*pList = NULL;
}

void pointOutput(struct point *el, FILE *f, char sep, char lastSep) 
/* Print out point.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
fprintf(f, "%d%c", el->x, sep);
fprintf(f, "%d%c", el->y, sep);
fprintf(f, "%d%c", el->z, lastSep);
}

struct autoTest *autoTestLoad(char **row)
/* Load a autoTest from row fetched with select * from autoTest
 * from database.  Dispose of this with autoTestFree(). */
{
struct autoTest *ret;
int sizeOne;
char *s;

AllocVar(ret);
ret->ptCount = sqlSigned(row[5]);
ret->difCount = sqlSigned(row[7]);
ret->valCount = sqlSigned(row[10]);
ret->id = sqlUnsigned(row[0]);
strcpy(ret->shortName, row[1]);
ret->longName = cloneString(row[2]);
s = cloneString(row[3]);
sqlStringArray(s, ret->aliases, 3);
s = row[4];
ret->threeD = pointCommaIn(&s);
sqlShortDynamicArray(row[6], &ret->pts, &sizeOne);
assert(sizeOne == ret->ptCount);
sqlUbyteDynamicArray(row[8], &ret->difs, &sizeOne);
assert(sizeOne == ret->difCount);
sqlSignedArray(row[9], ret->xy, 2);
sqlStringDynamicArray(row[11], &ret->vals, &sizeOne);
assert(sizeOne == ret->valCount);
return ret;
}

struct autoTest *autoTestCommaIn(char *s)
/* Create a autoTest out of a comma separated string. */
{
struct autoTest *ret;
char *s = *pS;
int i;

AllocVar(ret);
ret->id = sqlUnsignedComma(&s);
ret->shortName = sqlSignedComma(&s);
ret->longName = sqlStringComma(&s);
s = sqlEatChar(s, '{');
for (i=0; i<3; ++i)
    {
    ret->aliases = sqlStringComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
s = sqlEatChar(s, '{');
ret->threeD = pointCommaIn(&s)
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
ret->ptCount = sqlSignedComma(&s);
s = sqlEatChar(s, '{');
AllocArray(ret->pts, ptCount);
for (i=0; i<ret->ptCount; ++i)
    {
    ret->pts = sqlSignedComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
ret->difCount = sqlSignedComma(&s);
s = sqlEatChar(s, '{');
AllocArray(ret->difs, difCount);
for (i=0; i<ret->difCount; ++i)
    {
    ret->difs = sqlUnsignedComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
s = sqlEatChar(s, '{');
for (i=0; i<2; ++i)
    {
    ret->xy = sqlSignedComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
ret->valCount = sqlSignedComma(&s);
s = sqlEatChar(s, '{');
AllocArray(ret->vals, valCount);
for (i=0; i<ret->valCount; ++i)
    {
    ret->vals = sqlStringComma(&s);
    }
s = sqlEatChar(s, '}');
s = sqlEatChar(s, ',');
*pS = s;
return ret;
}

void autoTestFree(struct autoTest **pEl)
/* Free a single dynamically allocated autoTest such as created
 * with autoTestLoad(). */
{
struct autoTest *el;

if ((el = *pEl) == NULL) return;
freeMem(el->longName);
freeMem(el->aliases[0]);
pointFreeList(&el->threeD);
freeMem(el->pts);
freeMem(el->difs);
freeMem(el->vals[0]);
freeMem(el->vals);
freez(pEl);
}

void autoTestFreeList(struct autoTest **pList)
/* Free a list of dynamically allocated autoTest's */
{
struct autoTest *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    autoTestFree(&el);
    }
*pList = NULL;
}

void autoTestOutput(struct autoTest *el, FILE *f, char sep, char lastSep) 
/* Print out autoTest.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
fprintf(f, "%u%c", el->id, sep);
fprintf(f, "%s%c", el->shortName, sep);
fprintf(f, "%s%c", el->longName, sep);
for (i=0; i<3; ++i)
    fprintf(f, "%s,", el->aliases[i]);
fputc(sep,f);
pointCommaOut(el->threeD,f);
fputc(sep,f);
fprintf(f, "%d%c", el->ptCount, sep);
for (i=0; i<el->ptCount; ++i)
    fprintf(f, "%d,", el->pts[i]);
fputc(sep,f);
fprintf(f, "%d%c", el->difCount, sep);
for (i=0; i<el->difCount; ++i)
    fprintf(f, "%u,", el->difs[i]);
fputc(sep,f);
for (i=0; i<2; ++i)
    fprintf(f, "%d,", el->xy[i]);
fputc(sep,f);
fprintf(f, "%d%c", el->valCount, sep);
for (i=0; i<el->valCount; ++i)
    fprintf(f, "%s,", el->vals[i]);
fputc(lastSep,f);
}

